/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_

#include "element_2d.h"
#include "render_2d.h"

#include "graphics_engine.h"
#include "p_node.h"

using namespace std;


/**
 * standard constructor
 * @todo this constructor is not jet implemented - do it
*/
Element2D::Element2D ()
{
   this->setClassID(CL_ELEMENT_2D, "Element2D");

   Render2D::getInstance()->registerElement2D(this);
}

/**
 * standard deconstructor
*/
Element2D::~Element2D ()
{
  // delete what has to be deleted here
  Render2D::getInstance()->unregisterElement2D(this);
}


/**
 * this sets the position of the Element on the screen.
 */
void Element2D::positioning()
{
  // setting the Position of this ELEM2D.
  Vector pos;
  if (this->bindNode)
  {
    GLdouble x = this->bindNode->getAbsCoor().x;
    GLdouble y = this->bindNode->getAbsCoor().y;
    GLdouble z = this->bindNode->getAbsCoor().z;
    GLdouble projectPos[3];
    gluProject(x, y, z, GraphicsEngine::modMat, GraphicsEngine::projMat, GraphicsEngine::viewPort, projectPos, projectPos+1, projectPos+2);
    pos.x = projectPos[0] + this->position2D[0];
    pos.y = GraphicsEngine::getInstance()->getResolutionY() - projectPos[1] + this->position2D[1];
    pos.z = projectPos[2];
  }
  else
  {
    pos.x = this->position2D[0];
    pos.y = this->position2D[1];
    pos.z = 0;
  }

  glPushMatrix();
}

